<?php
/*
Plugin Name: Hide Custom Permalinks Field
Plugin URI: http://michael.tyson.id.au/wordpress/plugins/custom-permalinks
Donate link: http://michael.tyson.id.au/wordpress/plugins/custom-permalinks
Description: Hide the 'custom_permalink' post custom field
Version: 0.1
Author: Michael Tyson
Author URI: http://atastypixel.com/blog
*/

/*  Copyright 2008 Michael Tyson <michael@atastypixel.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define("HCPF_ALL_POST_META_QUERY_MATCH", '/SELECT\s+meta_key,\s+meta_value,\s+meta_id,\s+post_id\s+FROM\s+wp_postmeta\s+WHERE\s+post_id\s+=\s+[0-9]+\s+ORDER\s+BY\s+meta_key,meta_id/');

function hcpf_query_filter($query) {
    if ( preg_match(HCPF_ALL_POST_META_QUERY_MATCH, $query) ) {
        $query = str_replace('WHERE', 'WHERE meta_key != "custom_permalink" AND', $query);
    }
    return $query;
}

add_filter('query', 'hcpf_query_filter');

?>